﻿/**************************************************************************
@ file name CirclesPanel.jsx
@ description canvasにcircleを配置する
@ version 1.0
@ author Tsudoi Yoshimoto
@ url http://tsudoi.org/weblog/?p=1352
@ last update date 2013.05.23
**************************************************************************/

//Event
var make = 'Mk  '; //make

var doc;
var docW = 0;
var docH = 0;
var circleW = 50;
var circleH = 50;

var readJSsrc = 'Plug-ins/Panels/CirclesPanel/circlesCanvas.js';

/*
* description : 初期設定
*/
function init(){
    doc = app.activeDocument;
    docW = doc.width;
    docH = doc.height; 
}

/*
* description : カラーを設定する
* param _desc(ActionDescriptor) : 対象ActionDescriptor
* param _color(object) : カラーオブジェクト
*/
function setColor(_desc, _color){
    var _idType = charIDToTypeID( "Type" );
    var _desc2 = new ActionDescriptor();
        var _idClr = charIDToTypeID( "Clr " );
        var _desc3 = new ActionDescriptor();
                var _idRd = charIDToTypeID( "Rd  " );
                _desc3.putDouble( _idRd, _color.red );
                var _idGrn = charIDToTypeID( "Grn " );
                _desc3.putDouble( _idGrn, _color.green );
                var _idBl = charIDToTypeID( "Bl  " );
                _desc3.putDouble( _idBl, _color.blue );
        var _idRGBC = charIDToTypeID( "RGBC" );
        _desc2.putObject( _idClr, _idRGBC, _desc3 );  
    var _idsolidColorLayer = stringIDToTypeID( "solidColorLayer" );
    _desc.putObject( _idType, _idsolidColorLayer, _desc2 );
}

/*
* description : 線のカラーを設定する
* param _desc(ActionDescriptor) : 対象ActionDescriptor
* param _color(object) : カラーオブジェクト
*/
function setStrokeColor(_desc, _color){
    var idstrokeStyleContent = stringIDToTypeID( "strokeStyleContent" );
    var _desc2 = new ActionDescriptor();
        var _idClr = charIDToTypeID( "Clr " );
        var _desc3 = new ActionDescriptor();
                var _idRd = charIDToTypeID( "Rd  " );
                _desc3.putDouble( _idRd, _color.red );
                var _idGrn = charIDToTypeID( "Grn " );
                _desc3.putDouble( _idGrn, _color.green );
                var _idBl = charIDToTypeID( "Bl  " );
                _desc3.putDouble( _idBl, _color.blue );
        var _idRGBC = charIDToTypeID( "RGBC" );
        _desc2.putObject( _idClr, _idRGBC, _desc3 );  
    var _idsolidColorLayer = stringIDToTypeID( "solidColorLayer" );
    _desc.putObject( idstrokeStyleContent, _idsolidColorLayer, _desc2 );
}

/*
* description : 描画する
* param _desc(ActionDescriptor) : 対象ActionDescriptor
* param _type(string) : 描画タイプ
* param _bounds(object) : 範囲
*/
function setDraw(_desc, _type, _bounds){
    var _idShp = charIDToTypeID( "Shp " );
        var _desc2 = new ActionDescriptor();
            var idTop = charIDToTypeID( "Top " );
            var idPxl = charIDToTypeID( "#Pxl" );
            _desc2.putUnitDouble( idTop, idPxl, _bounds.top );
            var idLeft = charIDToTypeID( "Left" );
            var idPxl = charIDToTypeID( "#Pxl" );
            _desc2.putUnitDouble( idLeft, idPxl, _bounds.left );
            var idBtom = charIDToTypeID( "Btom" );
            var idPxl = charIDToTypeID( "#Pxl" );
            _desc2.putUnitDouble( idBtom, idPxl, _bounds.bottom );
            var idRght = charIDToTypeID( "Rght" );
            var idPxl = charIDToTypeID( "#Pxl" );
            _desc2.putUnitDouble( idRght, idPxl, _bounds.right );
    var _idType = charIDToTypeID(_type);
    _desc.putObject( _idShp, _idType, _desc2 );
}

/*
* description : 線を設定する
* param _desc(ActionDescriptor) : 対象ActionDescriptor
*/
function setStroke(_desc){
    var _idstrokeStyle = stringIDToTypeID( "strokeStyle" );
    var _desc2 = new ActionDescriptor();
    
        //version
        var _idstrokeStyleVersion = stringIDToTypeID( "strokeStyleVersion" );
        _desc2.putInteger( _idstrokeStyleVersion, 2 );
        
        //stroke enabled
        var _idstrokeEnabled = stringIDToTypeID( "strokeEnabled" );
        _desc2.putBoolean( _idstrokeEnabled, true );
        
        //fill enabled
        var _idfillEnabled = stringIDToTypeID( "fillEnabled" );
        _desc2.putBoolean( _idfillEnabled, true );
        
        //stroke style line width
        var _idstrokeStyleLineWidth = stringIDToTypeID( "strokeStyleLineWidth" );
        var _idPnt = charIDToTypeID( "#Pnt" );
        _desc2.putUnitDouble( _idstrokeStyleLineWidth, _idPnt, 3 );            
        
        //stroke style line dash offset
        var _idstrokeStyleLineDashOffset = stringIDToTypeID( "strokeStyleLineDashOffset" );
        var _idPnt = charIDToTypeID( "#Pnt" );
        _desc2.putUnitDouble( _idstrokeStyleLineDashOffset, _idPnt, 0 );    
        
        //stroke style miter limit
        var _idstrokeStyleMiterLimit = stringIDToTypeID( "strokeStyleMiterLimit" );
        _desc2.putDouble( _idstrokeStyleMiterLimit, 100 );
        
        //stroke style line cap type
        var _idstrokeStyleLineCapType = stringIDToTypeID( "strokeStyleLineCapType" );
        var _idstrokeStyleLineCapType = stringIDToTypeID( "strokeStyleLineCapType" );
        var _idstrokeStyleButtCap = stringIDToTypeID( "strokeStyleButtCap" );
        _desc2.putEnumerated( _idstrokeStyleLineCapType, _idstrokeStyleLineCapType, _idstrokeStyleButtCap );
        
        //stroke style line join type
        var _idstrokeStyleLineJoinType = stringIDToTypeID( "strokeStyleLineJoinType" );
        var _idstrokeStyleLineJoinType = stringIDToTypeID( "strokeStyleLineJoinType" );
        var _idstrokeStyleMiterJoin = stringIDToTypeID( "strokeStyleMiterJoin" );
        _desc2.putEnumerated( _idstrokeStyleLineJoinType, _idstrokeStyleLineJoinType, _idstrokeStyleMiterJoin );
        
        //stroke style line alignment
        var _idstrokeStyleLineAlignment = stringIDToTypeID( "strokeStyleLineAlignment" );
        var _idstrokeStyleLineAlignment = stringIDToTypeID( "strokeStyleLineAlignment" );
        var _idstrokeStyleAlignInside = stringIDToTypeID( "strokeStyleAlignInside" );
        _desc2.putEnumerated( _idstrokeStyleLineAlignment, _idstrokeStyleLineAlignment, _idstrokeStyleAlignInside );
        
        //stroke style scale lock
        var _idstrokeStyleScaleLock = stringIDToTypeID( "strokeStyleScaleLock" );
        _desc2.putBoolean( _idstrokeStyleScaleLock, false );
        
        //stroke style adjust
        var _idstrokeStyleStrokeAdjust = stringIDToTypeID( "strokeStyleStrokeAdjust" );
        _desc2.putBoolean( _idstrokeStyleStrokeAdjust, false );
        
        //stroke style line dash set
        var _idstrokeStyleLineDashSet = stringIDToTypeID( "strokeStyleLineDashSet" );
        var _list2 = new ActionList();
        _desc2.putList( _idstrokeStyleLineDashSet, _list2 );
        
        //stroke style blend mode
        var _idstrokeStyleBlendMode = stringIDToTypeID( "strokeStyleBlendMode" );
        var _idBlnM = charIDToTypeID( "BlnM" );
        var _idNrml = charIDToTypeID( "Nrml" );
        _desc2.putEnumerated( _idstrokeStyleBlendMode, _idBlnM, _idNrml );
        
        //stroke style opacity
        var _idstrokeStyleOpacity = stringIDToTypeID( "strokeStyleOpacity" );
        var _idPrc = charIDToTypeID( "#Prc" );
        _desc2.putUnitDouble( _idstrokeStyleOpacity, _idPrc, 100.000000 );
        
        setStrokeColor(_desc2, {'red':0, 'green':255, 'blue':0});
        
        //stroke style resolution
        var _idstrokeStyleResolution = stringIDToTypeID( "strokeStyleResolution" );
        _desc2.putDouble( _idstrokeStyleResolution, 72.000000 );
            
    var _idstrokeStyle = stringIDToTypeID( "strokeStyle" );
    _desc.putObject( _idstrokeStyle, _idstrokeStyle, _desc2 );

}

/*
* description : ガイドをひく
* param _type(string) : Vrtc(Vertical) or Hrzn(Horizon)
* param _p(number) : 座標
*/
function addGuide(_type, _p){
    var _idMake = charIDToTypeID(make);
    var _desc = new ActionDescriptor();
    var _idNw = charIDToTypeID( "Nw  " );
    
        var _desc2 = new ActionDescriptor();
        
        //座標
        var _idPstn = charIDToTypeID( "Pstn" );
        var _idPxl = charIDToTypeID( "#Pxl" );
        _desc2.putUnitDouble( _idPstn, _idPxl, _p );
        
        //type
        var _idOrnt = charIDToTypeID( "Ornt" );
        var _idOrnt = charIDToTypeID( "Ornt" );
        var _idType = charIDToTypeID(_type);
        _desc2.putEnumerated( _idOrnt, _idOrnt, _idType );
        
    var _idGd = charIDToTypeID( "Gd  " );
    _desc.putObject( _idNw, _idGd, _desc2 );        
    executeAction( _idMake, _desc, DialogModes.NO );
}

/*
* description : 円を描く
* param _prop(object) : 'x','y','width','height'
* param _radius(number) : 半径
* param _color(object) : カラーオブジェクト
*/
function drawCircle(_prop, _radius, _color){
    var _idMake = charIDToTypeID(make);
    var _desc = new ActionDescriptor();

        /* */
        var _idnull = charIDToTypeID( "null" );
        var _ref = new ActionReference();
            var _idcontentLayer = stringIDToTypeID( "contentLayer" );
            _ref.putClass( _idcontentLayer );
        _desc.putReference( _idnull, _ref );

        /* */
        var _idUsng = charIDToTypeID( "Usng" );
        var _desc2 = new ActionDescriptor();
            setColor(_desc2, _color);
            
            var _top = _prop.y + Math.round((_prop.height-_radius)/2);
            var _left = _prop.x + Math.round((_prop.width-_radius)/2);
            var _bottom = _top + _radius;
            var _right = _left + _radius;
            
            setDraw(_desc2, "Elps", {'top':_top, 'left':_left, 'bottom':_bottom, 'right':_right});
            //setStroke(_desc2);
        var _idcontentLayer = stringIDToTypeID( "contentLayer" );
        _desc.putObject( _idUsng, _idcontentLayer, _desc2 );

    executeAction( _idMake, _desc, DialogModes.NO );
}
    
function getCircles(_baseRadius){
    
    init();    

    circleW = _baseRadius;
    circleH = _baseRadius;

    var _xml = "<object>"; 
    //_xml += convertToXML(docW, 'canvasWidth');
    //_xml += convertToXML(docH, 'canvasHeight');
    
    //var _baseRadius = 25;
    var _v = Math.ceil( docW / circleW ); //垂直線(Vertical)
    var _h = Math.ceil( docH / circleH ); //水平線(Horizon )
    var _len = _v*_h;
    
    //_xml += convertToXML(_len, 'itemLength');
    
    var i;
    var j;
    var _radius = 0;
    var _red = 0;
    var _green = 0;
    var _blue = 0;
    var _itemsCode = '';
    var _end = ',';

    var _redNum = ( Math.round(Math.random()*1) == 1 ) ? 120 : 30;
    var _greenNum = ( Math.round(Math.random()*1) == 1 ) ? 120 : 30;
    var _blueNum = ( Math.round(Math.random()*1) == 1 ) ? 120 : 30;
    
    for( i=0; i<_v; i++ ){
        //addGuide('Vrtc', circleW*i);
         for( j=0; j<_h; j++ ){
            //addGuide('Hrzn', circleH*j);
            _radius = Math.round( Math.random()*Math.round(_baseRadius/2) ) + (Math.round(_baseRadius/2));
            _red = Math.round( Math.random()*_redNum ) + _redNum;
            _green = Math.round( Math.random()*_greenNum ) + _greenNum;
            _blue = Math.round( Math.random()*_blueNum ) + _blueNum;
            drawCircle(
                {'x':circleW*i, 'y':circleH*j, 'width':circleW, 'height':circleH},
                _radius,
                {'red':_red, 'green':_green, 'blue':_blue}
            );
            if( i == _v-1 && j == _h-1 ){
                _end = '';
            }
            //_itemsCode += '{'+'x:'+(circleW*i)+',y:'+(circleH*j)+',width:'+circleW+',height:'+circleH+',radius:'+(_radius/2)+',color:'+'"rgba('+_red+','+_green+','+_blue+','+1+')"'+'}'+_end;
            _itemsCode += '{'+'x:'+(circleW*i)+',y:'+(circleH*j)+',width:'+circleW+',height:'+circleH+',radius:'+(_radius/2)+',red:'+_red+',green:'+_green+',blue:'+_blue+'}'+_end;
        }
        //drawCircle({'x':circleW*i, 'y':0, 'width':circleW, 'height':circleH}, radius);
    }
    
    //var _openFile = File.openDialog("読み込むファイルを選んでください","JSX-Script(*.jsx *.js):*.JSX;*.sJS;*.*");
    
    var _fileLineFeed = getFileLineFeed();
    var _path = '';
    if( _fileLineFeed == 'macintosh' ){
        _path = '/Applications/Adobe Photoshop CS6/';
        }
    //ベースとなるjsファイルを開く
    var _openFile = new File(_path+readJSsrc);
    _openFile.open("r");
    var _content = _openFile.readln();
    _openFile.close();

    //jsを保存する
    var _saveFile = File.saveDialog("Please select a file to export the text to:");
    if(_saveFile == null){
        alert("キャンセルしました。");
        return;
    }    
    var _filePath = _saveFile.path + "/" + _saveFile.name;
    var _fileOut = new File(_filePath);
    var _dummyFile = null;
    _fileOut.linefeed = _fileLineFeed;
    _fileOut.open("w", "TEXT", "????");
    
    var _code0 = 'function initCirclesCanvas(){';
    var _code1 = 'var _id = "circlesCanvas";';
    var _code2 = 'var _docW = '+parseInt(docW)+';';
    var _code3 = 'var _docH = '+parseInt(docH)+';';
    var _code4 = 'var _circleW = '+circleW+';';
    var _code5 = 'var _circleH = '+circleH+';';
    var _code6 = 'var _items = [' +_itemsCode+ '];';

    _fileOut.writeln(_code0+_code1+_code2+_code3+_code4+_code5+_code6+_content);
    
    _fileOut.close();
    
    _xml += convertToXML( _fileOut.name, 'fileName' );
    _xml += "</object>";
    return _xml;
    
}

function reset(){
    var _layerLen = doc.layers.length;
    var i = 0;
    for( i=0; i<_layerLen; i++ ){
        if(!doc.layers[i].isBackgroundLayer) doc.layers[i].remove();
    }
}

function convertToXML(property, identifier){
	var type = typeof property;
	var xml = '<property id = "' + identifier + '" >';
	
	switch(type){
		case "number":
			xml += "<number>";
			xml += property.toString();
			xml += "</number>";
			break;
		case "boolean":
			xml += "<" + property.toString() + "/>";
			break;
		case "string":
			xml += "<string>";
			xml += property.toString();
			xml += "</string>";
			break;
		case "object":
			alertDebug("Object case is currently not supported");
			break;
		case "undefined":
			xml += "<string>undefined</string>";
			break;
		default:
			alertDebug("Type " + type + " is unknown.");
			return "";
	}
	xml += '</property>';
	return xml;
}

function getFileLineFeed(){
	if(
		$.os.search(/windows/i) != -1
	){
		return 'windows';
	}
	else{
		return 'macintosh';
	}
}